<?php
/*!***************************************************************************
*! FILE NAME  : reflash.php
*! DESCRIPTION: updating the camera firmware by running a remote script over NFS
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: reflash.php,v $
*!  Revision 1.3  2009/01/09 14:37:46  spectr_rain
*!  fixed options for NFS mount
*!
*!  Revision 1.2  2008/12/13 23:33:47  elphel
*!  Allow quoted sting in reflash.php?NFS="..."  -(non-quoted also works as it did before
*!
*!  Revision 1.1.1.1  2008/11/27 20:04:01  elphel
*!
*!
*!  Revision 1.4  2008/10/15 22:26:44  elphel
*!  Added warning (reflashing takes longer than script to run)
*!
*!  Revision 1.3  2008/10/13 05:14:19  elphel
*!  updated to NFS_ROOT/NFS_DIR
*!
*!  Revision 1.2  2008/10/12 22:17:56  elphel
*!  snapshot
*!
*!  Revision 1.4  2007/12/23 04:24:23  elphel
*!  umounts "store" flash partition
*!
*!  Revision 1.3  2007/12/11 23:28:15  spectr_rain
*!  added NET_FOLDER to use this folder and IP of request source
*!
*!  Revision 1.2  2007/11/20 00:53:33  elphel
*!  Verifies that  correct web server  is used
*!
*!  Revision 1.1  2007/11/08 06:29:37  elphel
*!  added reflash.php that allows camera firmware update from the using HTTP GET request
*!
*!
*/

  $mount_point="/var/tmp/nfs_mount_point";
  $mount_point_store="/mnt/.store";
  $remote_script="nfs_update";
  $error="";
  if (!$_SERVER["FCGI_ROLE"]) $error="wrong web server (please try different port number)";
  if ($_GET['SCRIPT']) $remote_script=$_GET['SCRIPT'];
  if (array_key_exists('NFS',$_GET)) {
    $NFS=trim($_GET['NFS'],'"\\');
  } else {
    if (!(($NFS_FOLDER=$_GET['NFS_FOLDER']))) {
      $default_nfs=preg_grep("/NFS=/",file("/etc/reflash.conf", FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES));
      foreach ($default_nfs as $str) parse_str($str);
      $NFS=trim($NFS,' "\\');
    } else {
      $NFS_IP=$_SERVER["REMOTE_ADDR"];
      $NFS=$NFS_IP.":".$NFS_FOLDER;
    }
  }
  $NFS_ROOT=dirname ($NFS);
  $NFS_DIR= basename ($NFS);

  //! just in case - unmount /var/tmp/nfs_mount_point and delete it. Ignore any errors"
  exec("umount ".$mount_point." ; umount ".$mount_point_store." ; rmdir ".$mount_point);
  if (!mkdir($mount_point, 0777))   $error="mkdir ".$mount_point." failed";

//! trying to connect to NFS server
  if ($error=="") {
     system('mount -t nfs -o nolock,tcp '. $NFS_ROOT.' '.$mount_point, $retval);
     if ($retval != 0) {
       $error="Mount NFS (".$NFS_ROOT.")failed";
     }
  }

//! We are in!
  if ($error=="") {
    if (!is_file($mount_point."/".$NFS_DIR."/".$remote_script)) {
       $error="Remote script ".$NFS_DIR."/".$remote_script." does not exist on NFS server at ".$NFS_ROOT;
    }
  }
  if ($error=="") $msg="<?xml version=\"1.0\"?>\n<reflash>\n<status>OK</status>\n<warning>\"Please do not disconnect the camera until reflashing is complete (under 1 minute)\"</warning>\n</reflash>\n";
  else            $msg=sprintf("<?xml version=\"1.0\"?>\n<reflash>\n  <error>\"%s\"</error>\n</reflash>\n",$error);
//! nothing should be output before header() !
//! It is important to send Content-Length before going to reflash, else browser will wait forever for more,
//!   even if the actual text has been sent out and got to the browser
  header("Content-Type: text/xml");
  header("Content-Length: ".strlen($msg)."\n");
  header("Pragma: no-cache\n");
  printf($msg);
//! Say goodbye and reflash
  ob_flush();
  flush();
  if ($error=="") {
    exec ("cd ".$mount_point."/".$NFS_DIR." ; ./".$remote_script."  update");
  }
?>
