/*#OUTPUT_FORMAT(elf32-us-cris) */
OUTPUT_ARCH (crisv32)

MEMORY 
	{
	bootblk : ORIGIN = 0x38000000,
	          LENGTH = 0x00008000
	intmem  : ORIGIN = 0x38008000,
		  LENGTH = 0x00005000
	}

SECTIONS
{
	.text :
	{
		_stext = . ;
		*(.text)
		*(.rodata)
		*(.rodata.*)
		_etext = . ;
	} > bootblk
	.data :
	{
		*(.data)
		_edata = . ;
	} > bootblk
	.bss :
	{
		_bss = . ;
		*(.bss)
		_end = ALIGN( 0x10 ) ;
	} > intmem

	/* Get rid of stuff from EXPORT_SYMBOL(foo). */
	/DISCARD/ :
	{
	        *(__ksymtab_strings)
	        *(__ksymtab)
	}
}
