#!/bin/sh
CONFNAME=/etc/conf.d/myimgftp.conf
if [ ! -f $CONFNAME ]; then
  #configuration file is not included in distribution
  echo "Configuration file $CONFNAME not found. Dying."
  exit 0
fi
echo "Waiting for autoexposure and image_viewer to start"
sleep 20
#read all the parameters from the camera local file, set them once
INAME=`cat $CONFNAME | sed -n 's/^[\t ]*INAME[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
SERVER=`cat $CONFNAME | sed -n 's/^[\t ]*SERVER[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
USER=`cat $CONFNAME | sed -n 's/^[\t ]*USER[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
PASSWORD=`cat $CONFNAME | sed -n 's/^[\t ]*PASSWORD[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
REMOTE_DIR=`cat $CONFNAME | sed -n 's/^[\t ]*REMOTE_DIR[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
REMOTE_CONF_DIR=`cat $CONFNAME | sed -n 's/^[\t ]*REMOTE_CONF_DIR[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`

PERIOD=`cat $CONFNAME | sed -n 's/^[\t ]*PERIOD[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`

GAMMA=`cat $CONFNAME | sed -n 's/^[\t ]*GAMMA[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
COLORLEVEL=`cat $CONFNAME | sed -n 's/^[\t ]*COLORLEVEL[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
QUALITY=`cat $CONFNAME | sed -n 's/^[\t ]*QUALITY[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`

#gains - hex, 0..1f (0..4) 50..5f - 4..8
RED=`cat $CONFNAME | sed -n 's/^[\t ]*RED[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
GREEN=`cat $CONFNAME | sed -n 's/^[\t ]*GREEN[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
BLUE=`cat $CONFNAME | sed -n 's/^[\t ]*BLUE[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
#maxexposure in  microseconds 1000000 - 1sec
MAXEXPOSURE=`cat $CONFNAME | sed -n 's/^[\t ]*MAXEXPOSURE[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
#maxexposure in command line (in 100us)
MAXEXPOSURE_CL=`cat $CONFNAME | sed -n 's/^[\t ]*MAXEXPOSURE_CL[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
EXPOSUREOVERMAX=`cat $CONFNAME | sed -n 's/^[\t ]*EXPOSUREOVERMAX[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
EXPOSUREWINLEFT=`cat $CONFNAME | sed -n 's/^[\t ]*EXPOSUREWINLEFT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
EXPOSUREWINTOP=`cat $CONFNAME | sed -n 's/^[\t ]*EXPOSUREWINTOP[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
EXPOSUREWINWIDTH=`cat $CONFNAME | sed -n 's/^[\t ]*EXPOSUREWINWIDTH[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
EXPOSUREWINHEIGHT=`cat $CONFNAME | sed -n 's/^[\t ]*EXPOSUREWINHEIGHT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`

wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&Image.I0.Appearance.Resolution=2048x1536&Image.I0.Appearance.Compression=30&ImageSource.I0.Sensor.E_DcmHor=1&ImageSource.I0.Sensor.E_DcmVert=1" -O -
wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&e_dcm_hor=1&e_dcm_vert=1&e_woi_width=2048&e_woi_height=1536&ElphelExtensions.Enabled=yes&ImageSource.I0.Sensor.Exposure=auto&ImageSource.I0.Sensor.MaxExposureTime=$MAXEXPOSURE&ImageSource.I0.Sensor.E_Exposure.OverMax=$EXPOSUREOVERMAX&ImageSource.I0.Sensor.E_Exposure.WinLeft=$EXPOSUREWINLEFT&ImageSource.I0.Sensor.E_Exposure.WinTop=$EXPOSUREWINTOP&ImageSource.I0.Sensor.E_Exposure.WinWidth=$EXPOSUREWINWIDTH&ImageSource.I0.Sensor.E_Exposure.WinHeight=$EXPOSUREWINHEIGHT&bogus=1136250040246&ImageSource.I0.Sensor.E_Quality=$QUALITY&Image.I0.Appearance.ColorEnabled=yes&ImageSource.I0.Sensor.ColorLevel=$COLORLEVEL" -O /tmp/tmp
#temporarily - repeat settings with autoexp_ctrl
# just in case I will not get updated version - same with /usr/local/bin/autoexp_ctrl command line
/usr/local/bin/autoexp_ctrl -m $MAXEXPOSURE_CL
/usr/local/bin/autoexp_ctrl -o $EXPOSUREOVERMAX
/usr/local/bin/autoexp_ctrl -l $EXPOSUREWINLEFT
/usr/local/bin/autoexp_ctrl -t $EXPOSUREWINTOP
/usr/local/bin/autoexp_ctrl -w $EXPOSUREWINWIDTH
/usr/local/bin/autoexp_ctrl -h $EXPOSUREWINHEIGHT

#hello -IR >> /var/log/myimgftp.log
wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Gamma=$GAMMA" -O -
#hello -IR >> /var/log/myimgftp.log
wget "http://127.0.0.1/axis-cgi/jpg/image.cgi" -O /tmp/$INAME.jpeg
#hello -IR >> /var/log/myimgftp.log
hello -IW ba 2b $GREEN >> /var/log/myimgftp.log
hello -IW ba 2c $BLUE >> /var/log/myimgftp.log
hello -IW ba 2d $RED >> /var/log/myimgftp.log
hello -IW ba 2e $GREEN >> /var/log/myimgftp.log
#hello -IR >> /var/log/myimgftp.log
wget "http://127.0.0.1/axis-cgi/jpg/image.cgi" -O /tmp/$INAME.jpeg
hello -IR >> /var/log/myimgftp.log
sleep 20
# here is the forever loop
while [ 1 ] ; do
# first - delete old and read the new remote configuration file from the
  rm -f /tmp/$INAME.conf
#  sftpclient -g $SERVER  -k /tmp -l /tmp/$INAME.conf -c $REMOTE_CONF_DIR -d $INAME.conf -t $INAME.conf.tmp -u $USER -w $PASSWORD
  wget "ftp://$USER:$PASSWORD@$SERVER$REMOTE_CONF_DIR/$INAME.conf" -q -O /tmp/$INAME.conf
#now parse it and interpret each parameter
  if [ -f /tmp/$INAME.conf ]; then
    GAMMA=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*GAMMA[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $GAMMA ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Gamma=$GAMMA" -O - ; fi
    COLORLEVEL=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*COLORLEVEL[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $COLORLEVEL ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.ColorLevel=$COLORLEVEL" -O - ; fi
    QUALITY=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*QUALITY[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $QUALITY ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Quality=$QUALITY" -O - ; fi
#autoexposure control through video API  
    MAXEXPOSURE=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*MAXEXPOSURE[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $MAXEXPOSURE ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.MaxExposureTime=$MAXEXPOSURE" -O - ; fi
    EXPOSUREOVERMAX=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREOVERMAX[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREOVERMAX ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Exposure.OverMax=$EXPOSUREOVERMAX" -O - ; fi
    EXPOSUREWINLEFT=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINLEFT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINLEFT ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Exposure.WinLeft=$EXPOSUREWINLEFT" -O - ; fi
    EXPOSUREWINTOP=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINTOP[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINTOP ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Exposure.WinTop=$EXPOSUREWINTOP" -O - ; fi
    EXPOSUREWINWIDTH=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINWIDTH[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINWIDTH ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Exposure.WinWidth=$EXPOSUREWINWIDTH" -O - ; fi
    EXPOSUREWINHEIGHT=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINHEIGHT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINHEIGHT ];  then wget "http://127.0.0.1/axis-cgi/admin/param.cgi?action=update&ImageSource.I0.Sensor.E_Exposure.WinHeight=$EXPOSUREWINHEIGHT" -O - ; fi
# just in case I will not get updated version - same with /usr/local/bin/autoexp_ctrl command line
    MAXEXPOSURE_CL=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*MAXEXPOSURE_CL[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $MAXEXPOSURE_CL ];  then /usr/local/bin/autoexp_ctrl -m $MAXEXPOSURE_CL ; fi
    EXPOSUREOVERMAX=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREOVERMAX[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREOVERMAX ];  then /usr/local/bin/autoexp_ctrl -o $EXPOSUREOVERMAX ; fi
    EXPOSUREWINLEFT=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINLEFT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINLEFT ];  then /usr/local/bin/autoexp_ctrl -l $EXPOSUREWINLEFT ; fi
    EXPOSUREWINTOP=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINTOP[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINTOP ];  then /usr/local/bin/autoexp_ctrl -t $EXPOSUREWINTOP ; fi
    EXPOSUREWINWIDTH=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINWIDTH[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINWIDTH ];  then /usr/local/bin/autoexp_ctrl -w $EXPOSUREWINWIDTH ; fi
    EXPOSUREWINHEIGHT=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*EXPOSUREWINHEIGHT[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $EXPOSUREWINHEIGHT ];  then /usr/local/bin/autoexp_ctrl -h $EXPOSUREWINHEIGHT ; fi
# gains control - also bypassing video API  
    RED=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*RED[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $RED ];  then  hello -IW ba 2d $RED ;  fi  
    BLUE=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*BLUE[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $BLUE ]; then  hello -IW ba 2c $BLUE ; fi  
    GREEN=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*GREEN[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    if [ $GREEN ]; then hello -IW ba 2b $GREEN ; hello -IW ba 2e $GREEN ; fi  
#Update period too?
    PERIOD1=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*PERIOD[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
    RESTART=`cat /tmp/$INAME.conf | sed -n 's/^[\t ]*RESTART[\t ]*=[\t ]*\([^\t# ]*\).*$/\1/p'`
  fi
# Now get the image to camera memory
  wget "http://127.0.0.1/axis-cgi/jpg/image.cgi" -O /tmp/$INAME.jpeg
#and send it to the remote FTP  
  sftpclient -p $SERVER  -k /tmp -l /tmp/$INAME.jpeg -c $REMOTE_DIR -d $INAME.jpeg -t $INAME.tmp -u $USER -w $PASSWORD
#
  if [ $RESTART ] ; then
#check if it is already restarted
   wget "ftp://$USER:$PASSWORD@$SERVER$REMOTE_CONF_DIR/$INAME.restarted" -q -O /tmp/RESTARTED
   if [ ! -f /tmp/RESTARTED ] ; then
#create a file on remote server to prevent an endless loop if RESTART is left in remote config   
     echo "camera is restarted" > /tmp/RESTARTED
     sftpclient -p $SERVER  -k /tmp -l /tmp/RESTARTED -c $REMOTE_DIR -d $INAME.restarted -t $INAME.restarted.tmp -u $USER -w $PASSWORD
#now - reboot itself     
     wget "http://127.0.0.1/axis-cgi/admin/restart.cgi" -O -
   fi
  fi

#  sleep $1
  if [ $PERIOD1 ];  then
    sleep $PERIOD1
  else
    sleep $PERIOD
  fi  
#  sleep $PERIOD
done
