//main_functions.js

var xmlHttp;
var choose = 'static';
show_xml(choose);

function submit() {
	makeRequest('network_interface.php', '?q=change&req=netmask&new_netmask=' + document.getElementById('netmask_field').value);
	makeRequest('network_interface.php', '?q=change&req=broadcast&new_broadcast=' + document.getElementById('broadcast_field').value);
	makeRequest('network_interface.php', '?q=change&req=gateway&new_gateway=' + document.getElementById('gateway_field').value);
	makeRequest('network_interface.php', '?q=change&req=ip&new_ip=' + document.getElementById('ip_field').value);
	
	//var current_url = window.location;
	// redirect to new IP
	setTimeout('redirect()', 1000);
	
}

function redirect() {
	window.location = "http://" + document.getElementById('ip_field').value + "/camerasetup/setup.php?page=network";
}


function makeRequest(url, parameters) {
	http_request = false;
	if (window.XMLHttpRequest) { // Mozilla, Safari,...
		http_request = new XMLHttpRequest();
		if (http_request.overrideMimeType) {
			http_request.overrideMimeType('text/xml');
		}
	} else if (window.ActiveXObject) { // IE
		try {
			http_request = new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			try {
				http_request = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (e) {}
		}
	}
	if (!http_request) {
 		alert('Cannot create XMLHTTP instance');
 		return false;
	}
	http_request.onreadystatechange = process_request;
	http_request.open('GET', url + parameters, true);
	http_request.send(null);
}

function process_request() {
	if (http_request.readyState == 4) {
		if (http_request.status == 200) {
			
		}
	}
}
function show_xml(choose) {
	xmlHttp = new XMLHttpRequest();
	var url = './network_interface.php';
	url = url + "?q=" + choose;
	xmlHttp.onreadystatechange = stateChanged;
	xmlHttp.open("GET",url,true);
	xmlHttp.send(null);
}

function stateChanged() {
	if (xmlHttp.readyState == 4) {
		var xml = xmlHttp.responseXML;
		parse_ip(xml);
		parse_netmask(xml);
		parse_broadcast(xml);
		parse_gateway(xml);
		parse_serial(xml);
		parse_date(xml);
		parse_load(xml);
		parse_soft(xml);
		parse_ps(xml);
	}
}

function IsNumeric(input)
{
   var ValidChars = "0123456789";
   var IsNumber = true;
   var Char;
 
   for (i = 0; i < input.length && IsNumber == true; i++) 
      { 
      Char = input.charAt(i); 
      if (ValidChars.indexOf(Char) == -1) 
         {
         	IsNumber = false;
         }
      }
   return IsNumber;
}

function ip_validate() {
	var old_ip = xmlHttp.responseXML.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	var new_ip = document.getElementById('ip_field').value;
	
	if (old_ip != new_ip) {
		document.getElementById('ip_check').innerHTML = '<img src="images/careful.gif"> Entire new network address. Careful!';
	} 
	
	var new_ip_parts = new_ip.split(".", 4);
	var old_ip_parts = old_ip.split(".", 4);
	
	if ((new_ip_parts[0]+0 == old_ip_parts[0]+0) && (new_ip_parts[1]+0 == old_ip_parts[1]+0) && (new_ip_parts[2]+0 == old_ip_parts[2]+0) && (new_ip_parts[3]+0 != old_ip_parts[3]+0))
		document.getElementById('ip_check').innerHTML = '<img src="images/check.gif"> New IP is in the same network range and should therefore be safe to apply.';	
	
	if((!IsNumeric(new_ip_parts[0])) || (!IsNumeric(new_ip_parts[1])) || (!IsNumeric(new_ip_parts[2])) || (!IsNumeric(new_ip_parts[3]))) {
		document.getElementById('ip_check').innerHTML = '<img src="images/careful.gif"> New IP malformed!';
	}
	
	if((new_ip_parts[0] > 255) || (new_ip_parts[1] > 255) || (new_ip_parts[2] > 255) || (new_ip_parts[3] > 254) || (new_ip_parts[0] < 0) || (new_ip_parts[1] < 0) || (new_ip_parts[2] < 0) || (new_ip_parts[3] < 1)) {
		document.getElementById('ip_check').innerHTML = '<img src="images/careful.gif"> New IP malformed!';
	}
	
	if (old_ip == new_ip) {
		document.getElementById('ip_check').innerHTML = '';	
	}	
		
	gateway_validate();
	broadcast_validate();
}

function netmask_validate() {
	var old_netmask = xmlHttp.responseXML.getElementsByTagName('netmask')[0].childNodes[0].nodeValue;
	var new_netmask = document.getElementById('netmask_field').value;
	
	if (old_netmask != new_netmask) {
		document.getElementById('netmask_check').innerHTML = '<img src="images/careful.gif" title="Entire new netmask address. Careful!"> Careful!';
	} 
	
	var new_netmask_parts = new_netmask.split(".", 4);
	var old_netmask_parts = old_netmask.split(".", 4);
	
	if((!IsNumeric(new_netmask_parts[0])) || (!IsNumeric(new_netmask_parts[1])) || (!IsNumeric(new_netmask_parts[2])) || (!IsNumeric(new_netmask_parts[3]))) {
		document.getElementById('netmask_check').innerHTML = '<img src="images/careful.gif"> New Netmask malformed!';
	}
	
	if((new_netmask_parts[0] > 255) || (new_netmask_parts[1] > 255) || (new_netmask_parts[2] > 255) || (new_netmask_parts[3] > 255) || (new_netmask_parts[0] < 0) || (new_netmask_parts[1] < 0) || (new_netmask_parts[2] < 0) || (new_netmask_parts[3] < 0)) {
		document.getElementById('netmask_check').innerHTML = '<img src="images/careful.gif"> New Netmask malformed!';
		allow_reboot = false;
	}
	
	if (old_netmask == new_netmask) {
		document.getElementById('netmask_check').innerHTML = '';	
	}	
}

function gateway_validate() {
	var old_gateway = xmlHttp.responseXML.getElementsByTagName('gateway')[0].childNodes[0].nodeValue;
	var new_gateway = document.getElementById('gateway_field').value;
	
	if (old_gateway != new_gateway) {
		document.getElementById('gateway_check').innerHTML = '<img src="images/careful.gif" title="Entire new gateway address. Careful!"> Careful!';
	} 
	
	var new_gateway_parts = new_gateway.split(".", 4);
	var old_gateway_parts = old_gateway.split(".", 4);
	
	if((!IsNumeric(new_gateway_parts[0])) || (!IsNumeric(new_gateway_parts[1])) || (!IsNumeric(new_gateway_parts[2])) || (!IsNumeric(new_gateway_parts[3]))) {
		document.getElementById('gateway_check').innerHTML = '<img src="images/careful.gif"> New gateway malformed!';
	}
	
	if((new_gateway_parts[0] > 255) || (new_gateway_parts[1] > 255) || (new_gateway_parts[2] > 255) || (new_gateway_parts[3] > 255) || (new_gateway_parts[0] < 0) || (new_gateway_parts[1] < 0) || (new_gateway_parts[2] < 0) || (new_gateway_parts[3] < 0)) {
		document.getElementById('gateway_check').innerHTML = '<img src="images/careful.gif"> New gateway malformed!';
	}
	
	if (old_gateway == new_gateway) {
		document.getElementById('gateway_check').innerHTML = '';	
	}	
	
	var old_ip = xmlHttp.responseXML.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	var new_ip = document.getElementById('ip_field').value;
	if (old_ip != new_ip)
		document.getElementById('gateway_check').innerHTML = '<img src="images/careful.gif"> IP is about to be changed, does the gateway need to be altered as well?';
}

function broadcast_validate() {
	var old_broadcast = xmlHttp.responseXML.getElementsByTagName('broadcast')[0].childNodes[0].nodeValue;
	var new_broadcast = document.getElementById('broadcast_field').value;
	
	if (old_broadcast != new_broadcast) {
		document.getElementById('broadcast_check').innerHTML = '<img src="images/careful.gif" title="Entire new broadcast address. Careful!"> Careful!';
	} 
	
	var new_broadcast_parts = new_broadcast.split(".", 4);
	var old_broadcast_parts = old_broadcast.split(".", 4);
	
	if((!IsNumeric(new_broadcast_parts[0])) || (!IsNumeric(new_broadcast_parts[1])) || (!IsNumeric(new_broadcast_parts[2])) || (!IsNumeric(new_broadcast_parts[3]))) {
		document.getElementById('broadcast_check').innerHTML = '<img src="images/careful.gif"> New broadcast address malformed!';
	}
	
	if((new_broadcast_parts[0] > 255) || (new_broadcast_parts[1] > 255) || (new_broadcast_parts[2] > 255) || (new_broadcast_parts[3] > 254) || (new_broadcast_parts[0] < 0) || (new_broadcast_parts[1] < 0) || (new_broadcast_parts[2] < 0) || (new_broadcast_parts[3] < 1)) {
		document.getElementById('broadcast_check').innerHTML = '<img src="images/careful.gif"> New broadcast address malformed!';
	}
	
	if (old_broadcast == new_broadcast) {
		document.getElementById('broadcast_check').innerHTML = '';	
	}	
	
	var old_ip = xmlHttp.responseXML.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	var new_ip = document.getElementById('ip_field').value;
	if (old_ip != new_ip)
		document.getElementById('broadcast_check').innerHTML = '<img src="images/careful.gif"> IP is about to be changed, does the broadcast address need to be altered as well?';	
}

function check_alert() {
	
	
	//get server and client netmask
	var old_netmask = xmlHttp.responseXML.getElementsByTagName('netmask')[0].childNodes[0].nodeValue;
	var new_netmask = document.getElementById('netmask_field').value;
	//get server and client gateway
	var old_gateway = xmlHttp.responseXML.getElementsByTagName('gateway')[0].childNodes[0].nodeValue;
	var new_gateway = document.getElementById('gateway_field').value;
	//get server and client broadcast
	var old_broadcast = xmlHttp.responseXML.getElementsByTagName('broadcast')[0].childNodes[0].nodeValue;
	var new_broadcast = document.getElementById('broadcast_field').value;
	//compare these variables
	
	/*
	if (old_netmask != new_netmask) {
		netmask_msg = '<p>Netmask has been changed but not submmited</p>';
	} else if (old_netmask == new_netmask) {
		netmask_msg = "";
	}

	if (old_broadcast != new_broadcast) {
		broadcast_msg = '<p>broadcast has been changed but not submmited</p>';
	} else if (old_broadcast == new_broadcast) {
		broadcast_msg = "";
	}
	if (old_gateway != new_gateway) {
		gateway_msg = '<p>gateway has been changed but not submmited</p>';
	} else if (old_gateway == new_gateway) {
		gateway_msg = "";
	}*/
	//document.getElementById('alert').innerHTML = netmask_msg + ip_msg + gateway_msg + broadcast_msg;
}

function parse_ps(xml) {
	var ps = xml.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
	//document.getElementById('full_ps').innerHTML = ps;
	//document.getElementById('full_ps').innerHTML = xmlHttp.responseXML.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
}
var ps_shown = 0;
function show_ps() {
	var ps = document.getElementById('full_ps');
	if (ps_shown == 0) {
		ps.style.display = 'block';
		ps_shown = 1;
	} else if (ps_shown == 1) {
		ps.style.display = 'none';	
		ps_shown = 0;
	}
}

function parse_soft(xml) {
	var soft = xml.getElementsByTagName('version')[0].childNodes[0].nodeValue;
	//document.getElementById('version').innerHTML = soft;
	//document.getElementById('sourceLink').innerHTML = "<a href='/docs/" + soft + "'>/* source inside */</a>";
}

function parse_ip(xml) {
	var ip = xml.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	//document.getElementById('ip').innerHTML = ip;
	document.getElementById('ip_field').value = ip;
}

function parse_netmask(xml) {
	var netmask = xml.getElementsByTagName('netmask')[0].childNodes[0].nodeValue;
	//document.getElementById('netmask').innerHTML = netmask;
	document.getElementById('netmask_field').value = netmask;
}

function parse_broadcast(xml) {
	var broadcast = xml.getElementsByTagName('broadcast')[0].childNodes[0].nodeValue;
	//document.getElementById('broadcast').innerHTML = broadcast;
	document.getElementById('broadcast_field').value = broadcast;
}

function parse_gateway(xml) {
	var gateway = xml.getElementsByTagName('gateway')[0].childNodes[0].nodeValue;
	//document.getElementById('gateway').innerHTML = gateway;
	document.getElementById('gateway_field').value = gateway;
}

function parse_serial(xml) {
	var serial_no = xml.getElementsByTagName('serial_number')[0].childNodes[0].nodeValue;
	document.getElementById('serial_number').value = serial_no;
}

function parse_date(xml) {
	var cam_date = xml.getElementsByTagName('cam_date')[0].childNodes[0].nodeValue;
	//document.getElementById('cam_date').innerHTML = cam_date;
}

function parse_load(xml) {
	var load = xml.getElementsByTagName('load')[0].childNodes[0].nodeValue;
	//document.getElementById('load').innerHTML = load;
}
/*
function parse_ps(xml) {
	var ps = xml.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
	document.getElementById('proc').innerHTML = ps;	
}
*/

