<?php

/*
 * 		Copyright 2008 Elphel <elphel.com>
 *      This program is free software; you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 2 of the License, or
 *      (at your option) any later version.
 *      
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *      
 *      You should have received a copy of the GNU General Public License
 *      along with this program; if not, write to the Free Software
 *      Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 *      MA 02110-1301, USA.
 */

/*
 * FEATURES
 * This backend script features many ways to configure the camera for 
 * different uses. For example, one can, using this interface, 
 * change the ip of their camera, or set up a new netmask. This backend
 * also allows the user to interact with it using simple GET requests.
 * further documentation to follow.
 * 
 */


function getSoftware() {
	return "<a href='/docs/" . exec('ls /usr/html/docs') . "'>" . exec('ls /usr/html/docs') . "</a> (get source)";
	//return $to_out;
	}

function soft_ver() {
	exec('/bin/ls /usr/html/docs', $arr);
	return implode($arr);
}

function ps() {
	exec('ps -w', $arr); 
	function low_daemon($v)
	{
	 return (substr($v, -1) != ']');
	}
	$p = (array_filter($arr, "low_daemon"));
	return implode($p);
}

function getSerial() {
  $s=exec("/bin/bootblocktool -x SERNO");
  return substr($s,0,2).":".substr($s,2,2).":".substr($s,4,2).":".substr($s,6,2).":".substr($s,8,2).":".substr($s,10,2);
}

function fpga() {
	$arr = array();
	$s = exec("/bin/fpcf -r 13", $arr);
	return implode($arr);
}

function cat_interupts() {
	$arr = array();
	$s = exec("/bin/cat /proc/interrupts", $arr);
	echo implode($arr);
}

function cat_sdram() {
	$arr = array();
	$s = exec("/bin/cat /var/log/fpga_sdram_phase", $arr);
	echo implode($arr);
}


function read_ip() {
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	fclose($fr);
	$pattern = '/IP=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/';
	preg_match($pattern, $data, $matches);
	$string = implode($matches);
	$output = substr($string, 3);
	return $output;
}


function read_broadcast() {
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	fclose($fr);
	$pattern = '/BROADCAST=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/';
	preg_match($pattern, $data, $matches);
	$string = implode($matches);
	$output = substr($string, 10);
	return $output;
}


function read_gateway() {
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	fclose($fr);
	$pattern = '/GATEWAY=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/';
	preg_match($pattern, $data, $matches);
	$string = implode($matches);
	$output = substr($string, 8);
	return $output;
	}


function read_netmask() {
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	fclose($fr);
	$pattern = '/NETMASK=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/';
	preg_match($pattern, $data, $matches);
	$string = implode($matches);
	$output = substr($string, 8);
	return $output;
}

function change_gateway() {
	global $new_gateway;
	echo "<p>" . $new_gateway . " is set </p>";
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	$replace_value = "GATEWAY=" . $new_gateway;
	fclose($fr);
	preg_match('/GATEWAY=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/', $data, $matches);
	$replace = str_replace($matches[0], $replace_value, $data);
	$fw = fopen($myFile, 'w') or die ("Can't open file in write mode");
	fwrite($fw, $replace);
	fclose($fw);
	}
	
function change_broadcast() {
	global $new_broadcast;
	echo "<p>" . $new_broadcast . " is set </p>";
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	$replace_value = "BROADCAST=" . $new_broadcast;
	fclose($fr);
	preg_match('/BROADCAST=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/', $data, $matches);
	$replace = str_replace($matches[0], $replace_value, $data);
	$fw = fopen($myFile, 'w') or die ("Can't open file in write mode");
	fwrite($fw, $replace);
	fclose($fw);
	}
	
function changeIP() {
	global $new_ip;
	echo "<p>" . $new_ip . " is set </p>"; //debugging
	global $new_ip;
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	$replace_value = "IP=" . $new_ip;
	fclose($fr);
	preg_match('/IP=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/', $data, $matches);
	$replace = str_replace($matches[0], $replace_value, $data);
	$fw = fopen($myFile, 'w') or die ("Can't open file in write mode");
	fwrite($fw, $replace);
	fclose($fw);
	}

function change_netmask() {
	global $new_netmask;
	echo "<p>" . $new_netmask . " is set </p>";
	$myFile = "/etc/conf.d/net.eth0";
	$fr = fopen($myFile, 'r') or die("Can't open file in read mode");
	$data = fread($fr, filesize($myFile));
	$replace_value = "NETMASK=" . $new_netmask;
	fclose($fr);
	preg_match('/NETMASK=\b\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}\b/', $data, $matches);
	$replace = str_replace($matches[0], $replace_value, $data);
	$fw = fopen($myFile, 'w') or die ("Can't open file in write mode");
	fwrite($fw, $replace);
	fclose($fw);
	}
	

function read_date() {
	exec("/bin/date", $arr);
	return implode($arr);
}

function read_load() {
	exec("/bin/cat /proc/loadavg", $arr);
	return implode($arr);
	}
	
function daemon_counter(){
 #this is simply to count the number of keys for use by other functions
 		exec("ps -w", $raw_array);
 		unset($raw_array['0']); 
 			function rm($v){
			 return (substr($v, -1) != ']');
				}
			 $no_low_level = array_values(array_filter($raw_array, "rm"));		
	$x = count($no_low_level);
		return $x;
}	
$number_of_daemons = daemon_counter();

/*	Do Not Erase
function daemon_pid(){
 #removes low level daemons and trash data from the array.
 		exec("ps -w", $raw_array);
 		unset($raw_array['0']); 
 			function low_daemon($v){
			 return (substr($v, -1) != ']');
				}
			 $no_low_level = array_values(array_filter($raw_array, "low_daemon"));
			
	//reads pid numbers from each key in the array and puts them in an array
	//of their own to be put into xml		
	$x = count($no_low_level); #$x = number of keys
	$y = $x * 2; #counter for the loop
	$key = -1; #makes names for the array keys
	$pid_num_array = array();
		while($x < $y) {
		$x += 1;
		$key += 1;
		$pattern = '/\b[A-Za-z0-9]*\b/';
		preg_match($pattern, $no_low_level[$key], $match);
		$string = implode($match);
		$pid_num_array[$key] = $string;
		}
		//$prepared = implode (" ", $pid_num_array);
		return $pid_num_array;
}
* jeff, please learn to test functions before committing*/
//$pid = daemon_pid();

//Generate xml funtions begin
/*
$xml = new SimpleXMLElement("<?xml version='1.0'?><cam_info/>");
function gen_dynamic_xml() {
  //global $xml;
	global $pid;
	global $number_of_daemons;
	$keynum = $number_of_daemons * 2;
	$key = -1;

	$xml->addChild ('daemons');
	
	while($number_of_daemons < $keynum) {
	$number_of_daemons += 1;
	$key += 1;
	$pid = $xml->daemons->addChild('pid' . $pid[$key]);
	}
		$rslt=$xml->asXML();

	header("Content-Type: text/xml");
	header("Content-Length: ".strlen($rslt)."\n");
	header("Pragma: no-cache\n");
	printf($rslt);
	
	print_r($pid);
}
*/	
$xml = new SimpleXMLElement("<?xml version='1.0'?><cam_info/>");
function gen_static_xml() {
	global $xml;
	$xml->addChild ('software');
	$version = $xml->software->addChild('version',soft_ver());
	$network = $xml->software->addChild('network');
		$ip = $xml->software->network->addChild('ip', read_ip());
		$netmask = $xml->software->network->addChild('netmask', read_netmask());
		$broadcast = $xml->software->network->addChild('broadcast', read_broadcast());
		$gateway = $xml->software->network->addChild('gateway', read_gateway());
	$date = $xml->software->addChild('cam_date',read_date());
		//$day = $xml->software->date->addChild('day');
		//$month = $xml->software->date->addChild('month');
		//$year = $xml->software->date->addChild('year');
		//$time = $xml->software->date->addChild('time');
	$proc_info = $xml->software->addChild('proc_info');
	$load = $xml->software->proc_info->addChild('load',read_load());
	//array variable types need to be changed into strings
	$proc = $xml->software->proc_info->addChild('proc',"<pre>".ps()."</pre>");
	$xml->addChild ('hardware');
	$ser_no = $xml->hardware->addChild('serial_number',getSerial());

	$rslt=$xml->asXML();

	header("Content-Type: text/xml");
	header("Content-Length: ".strlen($rslt)."\n");
	header("Pragma: no-cache\n");
	printf($rslt);
}



function gen_dynamic_xml($req) {
	//echo $req." requested";
	$xml = new SimpleXMLElement(gen_static_xml());
	//global $xml;
	switch ($req) {
		case 'ps':
			$xml->addChild('software');
			$proc_info = $xml->software->addChild('proc_info');
			$proc = $xml->software->proc_info->addChild('proc',"<pre>".ps()."</pre>");
			break;
		case 'load':
			$load = $xml->software->proc_info->addChild('load',read_load());
			break;
		}
	//dynamic xml will go here based on case/request
	header("Content-Type: text/xml");
	header("Content-Length: ".strlen($rslt)."\n");
	header("Pragma: no-cache\n");
	$rslt=$xml->asXML();
	printf($rslt);
}
//initial GET and POST variables for global use
$req = $_GET['req'];
$q = $_GET['q'];

if ($_GET['new_ip'] == null) {
	$new_ip = $_POST['new_ip'];
} elseif (!($_GET['new_ip'] == null)) {
	$new_ip = $_GET['new_ip'];
}

if ($_GET['new_netmask'] == null) {
	$new_netmask = $_POST['new_netmask'];
} elseif (!($_GET['new_netmask'] == null)) {
	$new_netmask = $_GET['new_netmask'];
}

if ($_GET['new_gateway'] == null) {
	$new_gateway = $_POST['new_gateway'];
} elseif (!($_GET['new_gateway'] == null)) {
	$new_gateway = $_GET['new_gateway'];
}

if ($_GET['new_broadcast'] == null) {
	$new_broadcast = $_POST['new_broadcast'];
} elseif (!($_GET['new_broadcast'] == null)) {
	$new_broadcast = $_GET['new_broadcast'];
}

if ($req == "" && $req == null && $q == "" && $q == null) {
	print_use();
} elseif ($q == 'change') {
		switch ($req) {
			case "ip":
				changeIP();
				echo "ip will be changed to " . $new_ip . " on reboot<p><a href='./UI.html'>return to main</a></p>";
				break;
			case "netmask":
				change_netmask();
				echo "netmask will be changed to " . $new_netmask . " on reboot<p><a href='./UI.html'>return to main</a></p>";
				break;
			case "gateway":
				change_gateway();
				echo "gateway will be changed to " . $new_gateway . " on reboot<p><a href='./UI.html'>return to main</a></p>";
				break;
			case "broadcast":
				change_broadcast();
				echo "broadcast will be changed to " . $new_broadcast . " on reboot<p><a href='./UI.html'>return to main</a></p>";
				break;
		}
	} else {
		switch ($q) {
			case "dynamic":
				gen_dynamic_xml($req);
				break;
			case "static" || "compile":
				gen_static_xml();
				break;
			}
		}
function print_use() {
	echo "<head><style type='text/css'>code {font-family:monospace} .variable{color:red}</style></head><body>";
	echo "<p>Usage:</p>";
	echo "<p><code>?q=static</code> or <code>?q=compile</code> &raquo; 
	print a compiled information sheet of every function</p>";
	echo "<p><code>?q=dynamic&amp;req=</code> or <code></code> &raquo; 
	print current information about one function</p>";
	
	echo "<p>These Network Functions cannot be strung together using 
	and in any case require a camera restart. They do not verify if the
	network selection is valid, so use at your own risk!</p>";
	
	echo "<p><code>?q=change&amp;req=ip</code> or 
	<code>?q=change&amp;req=ip&amp;new_ip=</code><span class='variable'>new ip</span> &raquo; change 
	the ip to the POST variable '<span class='variable'>new_ip</span>' or whatever is specified in the url</p>";
	echo "<p><code>?q=change&amp;req=netmask</code> or 
	<code>?q=change&amp;req=netmask&amp;new_netmask=</code><span class='variable'>new netmask</span> 
	&raquo; change the netmask to the POST variable '<span class='variable'>new_netmask</span>' or 
	whatever is specified in the url</p>";
	echo "<p><code>?q=change&amp;req=gateway</code> or 
	<code>?q=change&amp;req=gateway&amp;new_gateway=</code><span class='variable'>new gateway</span> 
	&raquo; change the gateway to the POST variable '<span class='variable'>new_gateway</span>' or 
	whatever is specified in the url</p>";
	echo "<p><code>?q=change&amp;req=broadcast</code> or
	<code>?q=change&amp;req=broadcast&amp;new_broadcast=</code><span class='variable'>new broadcast</span>
	&raquo; change the broadcast to the POST variable '<span class='variable'>new_broadcast</span>' or 
	whatever is specified in the url</p>";
	echo "</body>";
}


?>
