//main_functions.js

var xmlHttp;
var choose = 'static';
show_xml(choose);

function show_xml(choose) {
	xmlHttp = new XMLHttpRequest();
	var url = './backend.php';
	url = url + "?q=" + choose;
	xmlHttp.onreadystatechange = stateChanged;
	xmlHttp.open("GET",url,true);
	xmlHttp.send(null);
}

function stateChanged() {
	if (xmlHttp.readyState == 4) {
		var xml = xmlHttp.responseXML;
		parse_ip(xml);
		parse_netmask(xml);
		parse_broadcast(xml);
		parse_gateway(xml);
		parse_serial(xml);
		parse_date(xml);
		parse_load(xml);
		parse_soft(xml);
		parse_ps(xml);
	}
}

function check_alert() {
	//get server and client ip
	var old_ip = xmlHttp.responseXML.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	var new_ip = document.getElementById('ip_field').value;
	//get server and client netmask
	var old_netmask = xmlHttp.responseXML.getElementsByTagName('netmask')[0].childNodes[0].nodeValue;
	var new_netmask = document.getElementById('netmask_field').value;
	//get server and client gateway
	var old_gateway = xmlHttp.responseXML.getElementsByTagName('gateway')[0].childNodes[0].nodeValue;
	var new_gateway = document.getElementById('gateway_field').value;
	//get server and client broadcast
	var old_broadcast = xmlHttp.responseXML.getElementsByTagName('broadcast')[0].childNodes[0].nodeValue;
	var new_broadcast = document.getElementById('broadcast_field').value;
	//compare these variables
	if (old_netmask != new_netmask) {
		netmask_msg = '<p>Netmask has been changed but not submmited</p>';
	} else if (old_netmask == new_netmask) {
		netmask_msg = "";
	}
	if (old_ip != new_ip) {
		ip_msg = '<p>IP has been changed but not submmited</p>';
	} else if (old_ip == new_ip) {
		ip_msg = "";
	}
	if (old_broadcast != new_broadcast) {
		broadcast_msg = '<p>broadcast has been changed but not submmited</p>';
	} else if (old_broadcast == new_broadcast) {
		broadcast_msg = "";
	}
	if (old_gateway != new_gateway) {
		gateway_msg = '<p>gateway has been changed but not submmited</p>';
	} else if (old_gateway == new_gateway) {
		gateway_msg = "";
	}
	document.getElementById('alert').innerHTML = netmask_msg + ip_msg + gateway_msg + broadcast_msg;
}

function parse_ps(xml) {
	var ps = xml.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
	document.getElementById('full_ps').innerHTML = ps;
	//document.getElementById('full_ps').innerHTML = xmlHttp.responseXML.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
}
var ps_shown = 0;
function show_ps() {
	var ps = document.getElementById('full_ps');
	if (ps_shown == 0) {
		ps.style.display = 'block';
		ps_shown = 1;
	} else if (ps_shown == 1) {
		ps.style.display = 'none';	
		ps_shown = 0;
	}
}

function parse_soft(xml) {
	var soft = xml.getElementsByTagName('version')[0].childNodes[0].nodeValue;
	document.getElementById('version').innerHTML = soft;
	document.getElementById('sourceLink').innerHTML = "<a href='/docs/" + soft + "'>/* source inside */</a>";
}

function parse_ip(xml) {
	var ip = xml.getElementsByTagName('ip')[0].childNodes[0].nodeValue;
	document.getElementById('ip').innerHTML = ip;
	document.getElementById('ip_field').value = ip;
}

function parse_netmask(xml) {
	var netmask = xml.getElementsByTagName('netmask')[0].childNodes[0].nodeValue;
	document.getElementById('netmask').innerHTML = netmask;
	document.getElementById('netmask_field').value = netmask;
}

function parse_broadcast(xml) {
	var broadcast = xml.getElementsByTagName('broadcast')[0].childNodes[0].nodeValue;
	document.getElementById('broadcast').innerHTML = broadcast;
	document.getElementById('broadcast_field').value = broadcast;
}

function parse_gateway(xml) {
	var gateway = xml.getElementsByTagName('gateway')[0].childNodes[0].nodeValue;
	document.getElementById('gateway').innerHTML = gateway;
	document.getElementById('gateway_field').value = gateway;
}

function parse_serial(xml) {
	var serial_no = xml.getElementsByTagName('serial_number')[0].childNodes[0].nodeValue;
	document.getElementById('serial_number').innerHTML = serial_no;
}

function parse_date(xml) {
	var cam_date = xml.getElementsByTagName('cam_date')[0].childNodes[0].nodeValue;
	document.getElementById('cam_date').innerHTML = cam_date;
}

function parse_load(xml) {
	var load = xml.getElementsByTagName('load')[0].childNodes[0].nodeValue;
	document.getElementById('load').innerHTML = load;
}
/*
function parse_ps(xml) {
	var ps = xml.getElementsByTagName('proc')[0].childNodes[0].nodeValue;
	document.getElementById('proc').innerHTML = ps;	
}
*/
