<?php
/*!*******************************************************************************
*! FILE NAME  : compressor.php
*! DESCRIPTION: Provides control of FPGA compressor/image acquisition
*!              to the circular buffer (circbuf)
*! Copyright (C) 2007 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: compressor.php,v $
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.1  2007/12/06 19:02:50  elphel
*!  collected most of the camera PHP script into one  /packages/web/353/php_top directory
*!
*!  Revision 1.3  2007/10/31 04:59:41  elphel
*!  Included changes by Diego
*!
*!  Revision 1.2  2007/10/11 08:35:17  elphel
*!  fixed wrong file name in the header
*!
*!  Revision 1.1  2007/10/11 06:43:56  elphel
*!  Added two small PHP scripts to controll compressor (all sensors) and trigger (CCD with 10347 board only)
*!
*!
*/

 $cmd=$_GET['cmd'];
 switch  ($cmd) {
   case "run":   $cmd=0xa; break;
   case "stop":  $cmd=0xd; break;
   case "reset": $cmd=0x10; break;
 }
 if (is_numeric ($cmd) && ($cmd >=1) && ($cmd <= 0x10)) {
   $cmdfile=fopen('/dev/sensorpars', 'r');
   fseek ($cmdfile, $cmd+0, SEEK_END) ;
   fclose($cmdfile);
   echo <<<STATUS
   OK
STATUS;
 } else 
    echo <<<USAGE
   <p>This script controls FPGA compressor on the 10353 board. Sensor and input circuitry are supposed to be already programmed (for now use ccam.cgi).It accepts 3 mnemonic commands and numbers from 1 to 16 defined in <a href="http://elphel.cvs.sourceforge.net/elphel/elphel353-7.1/os/linux-2.6-tag--devboard-R2_10-4/include/asm-cris/elphel/c313a.h">os/linux-2.6/include/asm-cris/elphel/c313a.h</a>.</p>
   <ul>
    <li><b>cmd=run</b> - turn compressor on - it will compress all incoming sensor data and store it in circbuf, advancing write pointer and generating interrupts (that finish waits in imgsrv)</li>
    <li><b>cmd=stop</b> -  stop compressor (needed before changing of any acquisition (lake image size) or compression (quality) bparameters</li>
    <li><b>cmd=reset</b> - reset compressor circuitry, reinitialize circbuf</li>
    <li><b>cmd=1...16</b> - run command as described in c313.h, some commands may be outdated and/or not (yet) applicable to all sensors</li>
  </ul>
USAGE;
?>
