<?php
/*!***************************************************************************
*! FILE NAME  : sync.php
*! DESCRIPTION: sync boards detection /setup
*! Copyright (C) 2008 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: sync.php,v $
*!  Revision 1.2  2009/01/17 01:36:16  elphel
*!  removed elphel_trigger() - it is not needed and does not exist anymore in elphel PHP extension in 8.0
*!
*!  Revision 1.1.1.1  2008/11/27 20:04:03  elphel
*!
*!
*!  Revision 1.6  2008/03/25 07:38:43  elphel
*!  just troubleshooting
*!
*!  Revision 1.5  2008/03/22 04:43:03  elphel
*!  few minor changes
*!
*!  Revision 1.4  2008/03/21 01:20:19  elphel
*!  forces to use "role=sync" if no board is detected (so malfunctioning board will cause an error)
*!
*!  Revision 1.3  2008/03/21 01:10:34  elphel
*!  mode it work in "self" mode even if no sync board is detected.
*!
*!  Revision 1.2  2008/03/20 22:33:23  elphel
*!  control fof inter-cameras synchronization using 10369, 10371 boards
*!
*!  Revision 1.1  2008/03/17 17:44:39  elphel
*!  started sync.php to setup synchronization (10369/10371 boards)
*!
*!
*/

require 'i2c.inc';
function _returnXML($xml,$rslt=0) {
    $sxml=$xml->asXML();
    header("Content-Type: text/xml");
    header("Content-Length: ".strlen($sxml)."\n");
    header("Pragma: no-cache\n");
    printf($sxml);
    exit($rslt);
}
//!use file later
//bits can not be 0 - bit 0 is used by i2c
$xmlsyncstr = <<<XML
<?xml version='1.0'?>
<models>
 <m10369>
  <external>
   <in>
    <bit>10</bit>
    <polarity>0</polarity>
   </in>
   <out>
    <bit>11</bit>
    <polarity>0</polarity>
   </out>
  </external>
  <internal>
   <in>
    <bit>8</bit>
    <polarity>0</polarity>
   </in>
   <out>
    <bit>9</bit>
    <polarity>0</polarity>
   </out>
  </internal>
 </m10369>
 <m10371>
  <internal>
   <in>
    <bit>8</bit>
    <polarity>0</polarity>
   </in>
   <out>
    <bit>9</bit>
    <polarity>1</polarity>
   </out>
  </internal>
 </m10371>
</models>
XML;
   $self_only=false;
   $xmlsync = new SimpleXMLElement($xmlsyncstr);
   $s=exec("bootblocktool -x SERNO");
   $try_master=5;
   $try_master1=5+("0x".substr($s,11,1))+("0x".substr($s,10,1)); //randomize
   $busbits=array ( );
   $channel="self";
   $xml = new SimpleXMLElement("<?xml version='1.0' standalone='yes'?><sync/>");
   if (($_GET["channel"]=="self") || ($_GET["role"]=="self") || ($_GET["self"])) {
     $_GET["channel"]="self"; 
     $_GET["role"]="self"; 
     $self_only=true;
   }
   if (!$self_only) {
     $id_str=i2c_read256b();
     if ($id_str=="") {
       if ($_GET["role"]!="self") {
         $xml->addChild ('error','No sync capable board detected, use "role=self" for the onboard timer');
         _returnXML($xml,-1);
        }
        $xml->addChild ('board','none');
        $self_only=true;
     } else {
       $zero=strpos($id_str,chr(0));
       if ($zero!==false) $id_str=substr($id_str,0, $zero);
       if (substr($id_str,0,5)!="<?xml") {
         if ($_GET["role"]!="self") {
           $xml->addChild ('error','Corrupted sync board ID in the EEPROM, use "role=self" for the onboard timer');
           _returnXML($xml,-1);
         }
         $xml->addChild ('board','unidentified');
         $self_only=true;
       }
     }
   }
   if (!$self_only) {
     $xml_id = new SimpleXMLElement($id_str);
     $model=(string) $xml_id->model;
     $xml->addChild ('board',$model);
     $xml->addChild ('revision',(string) $xml_id->rev);
     $xml->addChild ('serial',(string) $xml_id->serial);
     $v= $xmlsync->{'m'.$model}->external->in->bit;       if ($v!==NULL) $busbits["external"]["in" ]["bit"]     = (integer) $v;
     $v= $xmlsync->{'m'.$model}->external->in->polarity;  if ($v!==NULL) $busbits["external"]["in" ]["polarity"]= (integer) $v;
     $v= $xmlsync->{'m'.$model}->external->out->bit;      if ($v!==NULL) $busbits["external"]["out"]["bit"]     = (integer) $v;
     $v= $xmlsync->{'m'.$model}->external->out->polarity; if ($v!==NULL) $busbits["external"]["out"]["polarity"]= (integer) $v;
     $v= $xmlsync->{'m'.$model}->internal->in->bit;       if ($v!==NULL) $busbits["internal"]["in" ]["bit"]     = (integer) $v;
     $v= $xmlsync->{'m'.$model}->internal->in->polarity;  if ($v!==NULL) $busbits["internal"]["in" ]["polarity"]= (integer) $v;
     $v= $xmlsync->{'m'.$model}->internal->out->bit;      if ($v!==NULL) $busbits["internal"]["out"]["bit"]     = (integer) $v;
     $v= $xmlsync->{'m'.$model}->internal->out->polarity; if ($v!==NULL) $busbits["internal"]["out"]["polarity"]= (integer) $v;
     if ($_GET["init"]!==NULL) {
       $xml->addChild ('initialize');
       if ($busbits["external"]["out"]>0) {
         $data=(2-$busbits["external"]["out" ]["polarity"])<<(2*$busbits["external"]["out" ]["bit"]);
         elphel_fpga_write(0x70,$data);
         $xml->initialize->addChild ('external_out',sprintf("0x%x",$data));
       }
       if ($busbits["external"]["in" ]>0) {
         $data=3<<(2*$busbits["external"]["in" ]["bit"]);
         elphel_fpga_write(0x70,$data);
         $xml->initialize->addChild ('external_in',sprintf("0x%x",$data));
       }
       if ($busbits["internal"]["out"]>0) {
         $data=(2-$busbits["internal"]["out" ]["polarity"])<<(2*$busbits["internal"]["out"]["bit"]);
         elphel_fpga_write(0x70,$data);
         $xml->initialize->addChild ('internal_out',sprintf("0x%x",$data));
       }
       if ($busbits["internal"]["in" ]>0) {
         $data=3<<(2*$busbits["internal"]["in" ]["bit"]);
         elphel_fpga_write(0x70,3<<(2*$busbits["internal"]["in" ]["bit"]));
         $xml->initialize->addChild ('internal_in',sprintf("0x%x",$data));
       }
     }
     $channel=(($_GET["channel"]=="external") || ($_GET["external"]))?"external":"internal";
     $xml->addChild ('channel',$channel);
     if ($busbits[$channel]["in" ]==0) {
        $xml->addChild ('error',sprintf("Channel %s is not implemented",$channel));
       _returnXML($xml,-1);
     }
   } else {
     $_GET["role"]="self";
   }
   $master=0;

   switch ($_GET["role"]) {
     case "master":
       $master=1;
     case "slave":
     case "self":
     case "":
      $role=$_GET["role"];
      break;
     case "detect":
      if ($busbits[$channel]["out" ]==0) $role="slave";
      else {
        elphel_fpga_write(0x70,0x8000000); //!disabling FPGA trigger signals to allow manual control
        elphel_fpga_write(0x70,(2-$busbits[$channel]["out" ]["polarity"])<<(2*$busbits[$channel]["out"]["bit"])); //turn off
        $master=((elphel_fpga_read(0x70)>>$busbits[$channel]["in" ]["bit"]) ^ $busbits[$channel]["in" ]["polarity"]) & 1;
        for ($i=0; ($i< $try_master) && ($master>0); $i++) {
          elphel_fpga_write(0x70,(1+$busbits[$channel]["out" ]["polarity"])<<(2*$busbits[$channel]["out"]["bit"])); //turn on
          $master &= ~((elphel_fpga_read(0x70)>>$busbits[$channel]["in" ]["bit"]) ^ $busbits[$channel]["in" ]["polarity"] );
          elphel_fpga_write(0x70,(2-$busbits[$channel]["out" ]["polarity"])<<(2*$busbits[$channel]["out"]["bit"])); //turn off
          for ($j=0;($j<rand(0,$try_master1)) && ($master>0);$j++) {
             elphel_fpga_write(0x70,(2-$busbits[$channel]["out" ]["polarity"])<<(2*$busbits[$channel]["out"]["bit"])); //turn off
             $master &= ((elphel_fpga_read(0x70)>>$busbits[$channel]["in" ]["bit"]) ^ $busbits[$channel]["in" ]["polarity"] );
          }
          if ($master==0) break;
        }
        $role=$master?"master":"slave";
      }
      break;
     default:
       $xml->addChild ('error',sprintf("Unknown role: %s",$_GET["role"]));
       _returnXML($xml,-1);
   }
   $xml->addChild ('role',$role);
   $trigger_parms=array();
   $sensor_clk=elphel_get_P_value(ELPHEL_CLK_SENSOR); //!programs sensor if not yet
   if ($_GET["pdelay"]!==NULL)    $trigger_parms["TRIG_DELAY"]= (integer) $_GET["pdelay"];
   if ($_GET["delay"]!==NULL)     $trigger_parms["TRIG_DELAY"]= (integer) ($_GET["delay"]*$sensor_clk);
   if ($_GET["fps"]!==NULL) {
     if      ($_GET["fps"]=="single")    $trigger_parms["TRIG_PERIOD"]= 1;
     else if ($_GET["fps"]=="stop")      $trigger_parms["TRIG_PERIOD"]= 0; //!stop
     else if ($_GET["fps"]>0)            $trigger_parms["TRIG_PERIOD"]= (integer) ($sensor_clk/$_GET["fps"]);
     else                                $trigger_parms["TRIG_PERIOD"]= 0; //!stop

   }
//!set trigger condition
   switch ($role) {
     case "self":
        $trigger_parms["TRIG_CONDITION"]= 0;
      break;
     case "master":
     case "slave":
        $trigger_parms["TRIG_CONDITION"]= (2+$busbits[$channel]["in" ]["polarity"])<< (2*$busbits[$channel]["in"]["bit"]);
      break;
   }
//!set output word
   switch ($role) {
     case "master":
        $trigger_parms["TRIG_OUT"]= (2+$busbits[$channel]["out" ]["polarity"])<< (2*$busbits[$channel]["out"]["bit"]);
        elphel_fpga_write(0x70,0xc000000); //!enabling FPGA trigger signals to propagate to the FPGA GPIO (not really needed here)
      break;
     case "slave":
     case "self":
        $trigger_parms["TRIG_OUT"]= 0;
        elphel_fpga_write(0x70,0x8000000); //!disabling FPGA trigger signals (not really needed here)
      break;
   }
   $xml->addChild ('trigger');
   foreach ($trigger_parms as $key=>$value) {
     $xml->trigger->addChild ($key,$value);
     $xml->trigger->addChild ($key."_HEX",sprintf("0x%x",$value));
   }
   elphel_set_P_arr($trigger_parms);
//   if (($role!="") && (count($trigger_parms)>0)){
//! don't program if role is not calculated
//! Why?
   if (count($trigger_parms)>0){
//! don't program if role is not calculated
///     elphel_trigger(); /// not needed in 8.0 (and does not exist there)
     $xml->trigger->addChild ('programmed',1);
   } else {
     $xml->trigger->addChild ('programmed',0);
   }
   $current_trigger=elphel_get_P_arr(Array("TRIG_DELAY"=>0,"TRIG_PERIOD"=>0,"TRIG_CONDITION"=>0,"TRIG_OUT"=>0));
   foreach ($current_trigger as $key=>$value) {
     $xml->trigger->addChild ($key,$value);
     $xml->trigger->addChild ($key."_HEX",sprintf("0x%x",$value));
   }
   _returnXML($xml,-0);
?>
