<?
/*!***************************************************************************
*! FILE NAME  : preset_interface.php
*! DESCRIPTION: command interface for the Preset Browser
*! Copyright (C) 2009 Elphel, Inc
*! -----------------------------------------------------------------------------**
*!
*!  This program is free software: you can redistribute it and/or modify
*!  it under the terms of the GNU General Public License as published by
*!  the Free Software Foundation, either version 3 of the License, or
*!  (at your option) any later version.
*!
*!  This program is distributed in the hope that it will be useful,
*!  but WITHOUT ANY WARRANTY; without even the implied warranty of
*!  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*!  GNU General Public License for more details.
*!
*!  You should have received a copy of the GNU General Public License
*!  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*! -----------------------------------------------------------------------------**
*!  $Log: preset_interface.php,v $
*!  Revision 1.2  2009/03/17 22:04:56  oneartplease
*!  presets can now be viewed and edited
*!
*!  loading presets works with sensor window settings only at the moment
*!
*!  some 8.0 adaptions
*!
*!  Revision 1.1  2009/01/14 08:17:12  oneartplease
*!  version 0.1 of the preset manager
*!
*!
*!  Revision 1.0  2009/01/03 Sebastian Pichelhofer
*!  
*!
*/
$cmd = $_GET['cmd'];

require_once('xml_simple.php');
function parse_array($element) 
{
	global $xmldata, $logindex;
	foreach ($element as $header => $value) 
	{
		if (is_array($value)) 
		{
			parse_array($value);
			$logindex++;
		} else 
		{
			$xmldata[$logindex][$header] = $value;
		}
	}
}
		
header("Content-type: text/xml"); 
header("Pragma: no-cache\n");

function xml_header() {
	echo "<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n";
	echo "<preset_interface>\n";
}
function xml_footer() {
	echo "</preset_interface>\n";
}

xml_header();
echo "<command>".$cmd."</command>";
echo "<".$cmd.">";

switch ($cmd)
{
	case "file_rename":
		if ((!isset($_GET['file_old'])) || (!isset($_GET['file_new'])))
		{
			echo "failed";
			break;
		}
		$old_name = $_GET['file_old'];
		$new_name = $_GET['file_new'];
		if ($old_name == $new_name)
			echo "1";
		else if (file_exists("/var/hdd/presets/".$new_name))
			echo "file exists";
		else
			echo rename("/var/hdd/".$old_name, "/var/hdd/presets/".$new_name);
		break;
	case "mount":
		exec('mkdir /var/hdd');
		exec('mount /dev/hda1 /var/hdd');
		echo "done";
		break;
	case "mkdir":
		$dir_name = $_GET['name'];
		if (isset($dir_name) && (($dir_name != "") || ($dir_name != " ")))
		{
			exec('mkdir /var/hdd/presets/'.$dir_name);
			echo "done";
			break;
		}
		else
			break;
	case "get_hdd_space":
		echo disk_free_space("/var/hdd");
		break;
	case "is_hdd_mounted":
		exec('mount', $arr);
		$mounted = implode("", $arr);
		if (strstr($mounted, "/dev/hda1"))
			echo substr($mounted, strpos($mounted, "/dev/hda1"),22);
		else
			echo "no HDD mounted";
		break;
	case "create_symlink":
		exec('ln -s /var/hdd /mnt/flash/html/hdd');
		break;
	case "list_files":
		if (!file_exists('/mnt/flash/html/hdd')) {
			echo "no webshare found";
		break;
		}
		if (!file_exists('/mnt/flash/html/hdd/presets'))
			exec('mkdir /var/hdd/presets');
		
		$dir = $_GET["dir"];
		
		if (isset($dir) && ($dir != "") && ($dir != "/./") && ($dir != "/"))  // show "one level up" item if we are not in "home" directory
		{
			echo "<file>";
			echo "<type>updir</type>";
			echo "<name>..</name>";
			$file_remove_last_slash = substr($dir, 0, strlen($dir)-1);
			$file_pos_of_second_last_slash = strrpos($file_remove_last_slash, "/");
			$up_file = substr($dir, 0, $file_pos_of_second_last_slash+1);
			while(strpos($up_file, "//")) {
				$up_file = str_replace("//", "/", $up_file); 
			}
			if ($up_file == "")
				echo "<path>/</path>";
			else
				echo "<path>".$up_file."</path>";
			echo "<desc></desc>";
			echo "<size>0</size>";
			echo "<date>0</date>";
			echo "</file>";
		}
		
		// real file
		if ($handle = opendir('/mnt/flash/html/hdd/presets'.$dir)) 
		{
			while ($file = readdir($handle))
			{
				if ($file != "." && $file != "..")
				{	
					echo "<file>";
					echo "<type>";
					if (is_dir("/var/hdd/presets/".$dir.$file))
						echo "dir";
					else
						echo $extension = substr($file, strrpos($file, '.')+1, strlen($file)); 
					echo "</type>";
					echo "<name>".$file."</name>";
					echo "<path>".substr($dir, 1).$file."</path>";
					
					if (!is_dir("/var/hdd/presets/".$dir.$file)) {
						// Load parameters from XML
						$preset_file = "/var/hdd/presets/".$dir.$file;
						$fh = fopen($preset_file, 'r');
						$content = fread($fh, filesize($preset_file));
						fclose($fh);
						
						$parser =& new xml_simple('UTF-8');
						$request = $parser->parse($content);
					
						// catch errors
						$error_code = 0;
						if (!$request) {
							$error_code = 1;
							echo("XML error: ".$parser->error);
						}
					
						$xmldata = array();
						$logindex = 0;
						parse_array($parser->tree);
						
						// load xml tags
						if ($xmldata[0]['PRESET_DESCRIPTION'])
							echo "<desc>".$xmldata[0]['PRESET_DESCRIPTION']."</desc>";
						else
							echo "<desc> </desc>";
					}
					else
						echo "<desc> </desc>";
							
					$size = filesize("/var/hdd/presets/".$dir.$file);
					echo "<size>".$size."</size>";
					$date = date("d M Y H:i:s", filectime("/var/hdd/presets/".$dir.$file));
					echo "<date>".$date."</date>";
					echo "</file>";
				}
			}
			closedir($handle);
		}
		else
			echo "no files or webshare found";
		break;
	case "update_parameters":
		echo "<ELPHEL_WOI_LEFT>".elphel_get_P_value(ELPHEL_WOI_LEFT)."</ELPHEL_WOI_LEFT>";
		echo "<ELPHEL_WOI_TOP>".elphel_get_P_value(ELPHEL_WOI_TOP)."</ELPHEL_WOI_TOP>";
		echo "<ELPHEL_WOI_WIDTH>".elphel_get_P_value(ELPHEL_WOI_WIDTH)."</ELPHEL_WOI_WIDTH>";
		echo "<ELPHEL_WOI_HEIGHT>".elphel_get_P_value(ELPHEL_WOI_HEIGHT)."</ELPHEL_WOI_HEIGHT>";
		echo "<ELPHEL_BIN_HOR>".elphel_get_P_value(ELPHEL_BIN_HOR)."</ELPHEL_BIN_HOR>";
		echo "<ELPHEL_BIN_VERT>".elphel_get_P_value(ELPHEL_BIN_VERT)."</ELPHEL_BIN_VERT>";
		echo "<ELPHEL_DCM_HOR>".elphel_get_P_value(ELPHEL_DCM_HOR)."</ELPHEL_DCM_HOR>";
		echo "<ELPHEL_DCM_VERT>".elphel_get_P_value(ELPHEL_DCM_VERT)."</ELPHEL_DCM_VERT>";
		echo "<ELPHEL_FLIP>";
		$flip_h = elphel_get_P_value(ELPHEL_FLIPH);
		$flip_v = elphel_get_P_value(ELPHEL_FLIPV);
		if($flip_h && $flip_v)
			echo "X &amp; Y";
		if(!$flip_h && $flip_v)
			echo "Y";
		if($flip_h && !$flip_v)							
			echo "X";
		if(!$flip_h && !$flip_v)
			echo "off";
		echo "</ELPHEL_FLIP>";	
		echo "<ELPHEL_FLIPV>".elphel_get_P_value(ELPHEL_FLIPV)."</ELPHEL_FLIPV>";
		echo "<ELPHEL_FLIPH>".elphel_get_P_value(ELPHEL_FLIPH)."</ELPHEL_FLIPH>";
		echo "<ELPHEL_COLOR>";
		echo elphel_get_P_value(ELPHEL_BITS)."bit ";
		switch (elphel_get_P_value(ELPHEL_COLOR))
		{
			case 0:
				echo "b/w";
				break;
			case 1:
				echo "color";
				break;
			case 2:
				echo "JP4";
				break;
			default :
				echo "Bars";
				break;
		}
		echo "</ELPHEL_COLOR>";
		echo "<ELPHEL_BITS>".elphel_get_P_value(ELPHEL_BITS)."</ELPHEL_BITS>";
		echo "<ELPHEL_CCOLOR>".elphel_get_P_value(ELPHEL_COLOR)."</ELPHEL_CCOLOR>";
		echo "<ELPHEL_QUALITY>".elphel_get_P_value(ELPHEL_QUALITY)."</ELPHEL_QUALITY>";
		echo "<ELPHEL_GAINR>".elphel_get_P_value(ELPHEL_GAINB)."</ELPHEL_GAINR>";
		echo "<ELPHEL_GAINB>".elphel_get_P_value(ELPHEL_GAINB)."</ELPHEL_GAINB>";			
		echo "<ELPHEL_GAING>".elphel_get_P_value(ELPHEL_GAING)."</ELPHEL_GAING>";		
		echo "<ELPHEL_GAINGB>".elphel_get_P_value(ELPHEL_GAINGB)."</ELPHEL_GAINGB>";
		echo "<ELPHEL_RSCALE>".elphel_get_P_value(ELPHEL_RSCALE)."</ELPHEL_RSCALE>";			
		echo "<ELPHEL_GSCALE>".elphel_get_P_value(ELPHEL_GSCALE)."</ELPHEL_GSCALE>";		
		echo "<ELPHEL_BSCALE>".elphel_get_P_value(ELPHEL_BSCALE)."</ELPHEL_BSCALE>";	
		echo "<ELPHEL_GAMMA>1</ELPHEL_GAMMA>";	//echo "<ELPHEL_GAMMA>".elphel_get_P_value(ELPHEL_GAMMA)."</ELPHEL_GAMMA>";	
		echo "<ELPHEL_PIXEL_LOW>1</ELPHEL_PIXEL_LOW>";	//echo "<ELPHEL_PIXEL_LOW>".elphel_get_P_value(ELPHEL_PIXEL_LOW)."</ELPHEL_PIXEL_LOW>";	
		echo "<ELPHEL_PIXEL_HIGH>1</ELPHEL_PIXEL_HIGH>";	//echo "<ELPHEL_PIXEL_HIGH>".elphel_get_P_value(ELPHEL_PIXEL_HIGH)."</ELPHEL_PIXEL_HIGH>";	
		echo "<ELPHEL_COLOR_SATURATION_RED>".elphel_get_P_value(ELPHEL_COLOR_SATURATION_RED)."</ELPHEL_COLOR_SATURATION_RED>";	
		echo "<ELPHEL_COLOR_SATURATION_BLUE>".elphel_get_P_value(ELPHEL_COLOR_SATURATION_BLUE)."</ELPHEL_COLOR_SATURATION_BLUE>";	
		echo "<ELPHEL_EXPOS>".elphel_get_P_value(ELPHEL_EXPOS)."</ELPHEL_EXPOS>";	
		echo "<ELPHEL_FP1000S>".elphel_get_P_value(ELPHEL_FP1000S)."</ELPHEL_FP1000S>";	
		break;
	case "save_preset":
		$preset_file = "/var/hdd/presets/".$_GET['preset_name'].".prs";
		$fh = fopen($preset_file, 'w');
		
		fwrite($fh, "<ELPHEL_CAMERA_PRESET name=\"".$_GET['preset_name']."\">\n");

		if(isset($_GET['desc']))
			fwrite($fh, "<PRESET_DESCRIPTION>".$_GET['desc']."</PRESET_DESCRIPTION>\n");

		if(isset($_GET['woi_left']))
			fwrite($fh, "<ELPHEL_WOI_LEFT>".$_GET['woi_left']."</ELPHEL_WOI_LEFT>\n");
		if(isset($_GET['woi_top']))
			fwrite($fh, "<ELPHEL_WOI_TOP>".$_GET['woi_top']."</ELPHEL_WOI_TOP>\n");
		if(isset($_GET['woi_width']))
			fwrite($fh, "<ELPHEL_WOI_WIDTH>".$_GET['woi_width']."</ELPHEL_WOI_WIDTH>\n");
		if(isset($_GET['woi_height']))
			fwrite($fh, "<ELPHEL_WOI_HEIGHT>".$_GET['woi_height']."</ELPHEL_WOI_HEIGHT>\n");
		if(isset($_GET['binning_hor']))
			fwrite($fh, "<ELPHEL_BIN_HOR>".$_GET['binning_hor']."</ELPHEL_BIN_HOR>\n");
		if(isset($_GET['binning_ver']))
			fwrite($fh, "<ELPHEL_BIN_VERT>".$_GET['binning_ver']."</ELPHEL_BIN_VERT>\n");
		if(isset($_GET['dec_hor']))
			fwrite($fh, "<ELPHEL_DCM_HOR>".$_GET['dec_hor']."</ELPHEL_DCM_HOR>\n");			
		if(isset($_GET['dec_ver']))
			fwrite($fh, "<ELPHEL_DCM_VERT>".$_GET['dec_ver']."</ELPHEL_DCM_VERT>\n");						
		if(isset($_GET['mirror']))
			fwrite($fh, "<ELPHEL_FLIP>".$_GET['mirror']."</ELPHEL_FLIP>\n");						
		if(isset($_GET['color']))
			fwrite($fh, "<ELPHEL_COLOR>".$_GET['color']."</ELPHEL_COLOR>\n");			
		if(isset($_GET['bits']))
			fwrite($fh, "<ELPHEL_BITS>".$_GET['bits']."</ELPHEL_BITS>\n");						
		if(isset($_GET['jpeg_qual']))
			fwrite($fh, "<ELPHEL_QUALITY>".$_GET['jpeg_qual']."</ELPHEL_QUALITY>\n");
		if(isset($_GET['gain_r']))
			fwrite($fh, "<ELPHEL_GAINR>".$_GET['gain_r']."</ELPHEL_GAINR>\n");						
		if(isset($_GET['gain_g']))
			fwrite($fh, "<ELPHEL_GAING>".$_GET['gain_g']."</ELPHEL_GAING>\n");			
		if(isset($_GET['gain_b']))
			fwrite($fh, "<ELPHEL_GAINB>".$_GET['gain_b']."</ELPHEL_GAINB>\n");						
		if(isset($_GET['gain_gb']))
			fwrite($fh, "<ELPHEL_GAINGB>".$_GET['gain_gb']."</ELPHEL_GAINGB>\n");
		if(isset($_GET['scale_r']))
			fwrite($fh, "<ELPHEL_RSCALE>".$_GET['scale_r']."</ELPHEL_RSCALE>\n");			
		if(isset($_GET['scale_g']))
			fwrite($fh, "<ELPHEL_GSCALE>".$_GET['scale_g']."</ELPHEL_GSCALE>\n");						
		if(isset($_GET['scale_b']))
			fwrite($fh, "<ELPHEL_BSCALE>".$_GET['scale_b']."</ELPHEL_BSCALE>\n");
		if(isset($_GET['gamma']))
			fwrite($fh, "<ELPHEL_GAMMA>".$_GET['gamma']."</ELPHEL_GAMMA>\n");			
		if(isset($_GET['black_level']))
			fwrite($fh, "<ELPHEL_PIXEL_LOW>".$_GET['black_level']."</ELPHEL_PIXEL_LOW>\n");						
		if(isset($_GET['white_level']))
			fwrite($fh, "<ELPHEL_PIXEL_HIGH>".$_GET['white_level']."</ELPHEL_PIXEL_HIGH>\n");
		if(isset($_GET['sat_r']))
			fwrite($fh, "<ELPHEL_COLOR_SATURATION_RED>".$_GET['sat_r']."</ELPHEL_COLOR_SATURATION_RED>\n");
		if(isset($_GET['sat_b']))
			fwrite($fh, "<ELPHEL_COLOR_SATURATION_BLUE>".$_GET['sat_b']."</ELPHEL_COLOR_SATURATION_BLUE>\n");			
		if(isset($_GET['exposure']))
			fwrite($fh, "<ELPHEL_EXPOS>".$_GET['exposure']."</ELPHEL_EXPOS>\n");						
		if(isset($_GET['fps']))
			fwrite($fh, "<ELPHEL_FP100S>".$_GET['fps']."</ELPHEL_FP1000S>\n");	
		fwrite($fh, "</ELPHEL_CAMERA_PRESET>\n");
		fclose($fh);
		
		// TODO return errors
		break;
		
	case "load_preset":
		$preset_file = "/var/hdd/presets/".$_GET['preset_name'];
		
		// Does the file exist
		if (file_exists($preset_file)) 
			echo "<load_preset_file>".$preset_file."</load_preset_file>";
		else
		{
			echo "<load_preset_file>ERROR: ".$preset_file." not found!</load_preset_file>";
			break;
		}
		// Load parameters from XML
		$fh = fopen($preset_file, 'r');
		$content = fread($fh, filesize($preset_file));
		fclose($fh);
	
		$parser =& new xml_simple('UTF-8');
		$request = $parser->parse($content);
	
		// catch errors
		$error_code = 0;
		if (!$request) {
		    $error_code = 1;
		    echo("XML error: ".$parser->error);
		}
	
		$xmldata = array();
		$logindex = 0;
		parse_array($parser->tree);
		
		// load xml tags
		$parameters['WOI_LEFT'] = (int)$xmldata[0]['ELPHEL_WOI_LEFT'];
		$parameters['WOI_TOP'] = (int)$xmldata[0]['ELPHEL_WOI_TOP'];
		$parameters["WOI_WIDTH"] = (int)$xmldata[0]['ELPHEL_WOI_WIDTH'];
		$parameters["WOI_HEIGHT"] = (int)$xmldata[0]['ELPHEL_WOI_HEIGHT'];
		$parameters["BIN_VERT"] = (int)$xmldata[0]['ELPHEL_BIN_VERT'];
		$parameters["BIN_HOR"] = (int)$xmldata[0]['ELPHEL_BIN_HOR'];
		$parameters["DCM_HOR"] = (int)$xmldata[0]['ELPHEL_DCM_HOR'];
		$parameters["DCM_VERT"] = (int)$xmldata[0]['ELPHEL_DCM_VERT'];		
		
		
		
		$processed_elements = elphel_set_P_arr($parameters, elphel_get_frame()+1, ELPHEL_CONST_FRAMEPAIR_FORCE_NEWPROC);
		
		// return results
		/*
		if ($processed_elements == sizeof($parameters))
			echo "<result>success! ".$processed_elements." parameters set</result>";
		else
			echo "<result>failed! ".sizeof($parameters)." parameters provided, but ".$processed_elements." set</result>";
		break;
		*/
}

echo "</".$cmd.">";
xml_footer();
?>

